/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *  MA 02110-1301, USA.
 *
 *  Copyright © 2006 Pierre Habouzit
 */

#ifndef MUTT_LIB_LIB_UTF8_H
#define MUTT_LIB_LIB_UTF8_H

/** \addtogroup mutt_strings */
/*@{*/

int m_ustrlen(const char *s);
int m_ustrgetc(const char *s, const char **outp);
int m_ustrputc(char *dst, ssize_t n, int c);

static inline char *m_vustrskipc(char *s) {
    if (*s++ & 0x80) {
        while ((*s & 0xc0) == 0x80)
            s++;
    }
    return s;
}

static inline const char *m_ustrskipc(const char *s) {
    return m_vustrskipc((char *)s);
}


/*@}*/
#endif /* MUTT_LIB_LIB_UTF8_H */
